#ifndef GLOBALS_H
#define GLOBALS_H

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#if HAVE_STDINT_H
#  include <stdint.h>
#endif
#ifdef HAVE_GL_GL_H
#  include <GL/gl.h>
#elif HAVE_OPENGL_GL_H
#  include <OpenGL/gl.h>
#endif
#include <SDL.h>
#include "events.h"
#include "height_quantity.h"

typedef struct{
  SDL_Surface *screen;
  int netcdfId;
  /* These are populated from the NetCDF file */
  size_t number_of_points;
  size_t number_of_vertices;
  size_t number_of_volumes;
  size_t number_of_timesteps;
  Sint32 current_frame;
  uint8_t paused;
  float *x;
  float *y;
  int *volumes;

  GLfloat pitch;
  GLfloat yaw;
  /* track is forward/back motion, strafe is side/side motion */
  GLfloat track;
  GLfloat strafe;
  GLfloat eye[3];
  GLfloat focus[3];
  uint8_t keys[KEY_MAX];

  struct height_quantity_simple *heights;
} ANUGAVIS;

extern ANUGAVIS anugavis;

#endif
